/**********************************************************************************************************************
 * DISCLAIMER
 * This software is supplied by Renesas Electronics Corporation and is only intended for use with Renesas products. No
 * other uses are authorized. This software is owned by Renesas Electronics Corporation and is protected under all
 * applicable laws, including copyright laws.
 * THIS SOFTWARE IS PROVIDED "AS IS" AND RENESAS MAKES NO WARRANTIES REGARDING
 * THIS SOFTWARE, WHETHER EXPRESS, IMPLIED OR STATUTORY, INCLUDING BUT NOT LIMITED TO WARRANTIES OF MERCHANTABILITY,
 * FITNESS FOR A PARTICULAR PURPOSE AND NON-INFRINGEMENT. ALL SUCH WARRANTIES ARE EXPRESSLY DISCLAIMED. TO THE MAXIMUM
 * EXTENT PERMITTED NOT PROHIBITED BY LAW, NEITHER RENESAS ELECTRONICS CORPORATION NOR ANY OF ITS AFFILIATED COMPANIES
 * SHALL BE LIABLE FOR ANY DIRECT, INDIRECT, SPECIAL, INCIDENTAL OR CONSEQUENTIAL DAMAGES FOR ANY REASON RELATED TO
 * THIS SOFTWARE, EVEN IF RENESAS OR ITS AFFILIATES HAVE BEEN ADVISED OF THE POSSIBILITY OF SUCH DAMAGES.
 * Renesas reserves the right, without notice, to make changes to this software and to discontinue the availability of
 * this software. By using this software, you agree to the additional terms and conditions found by accessing the
 * following link:
 * http://www.renesas.com/disclaimer
 *
 * Copyright (C) 2020 Renesas Electronics Corporation. All rights reserved.
 *********************************************************************************************************************/
/***********************************************************************/
/*                                                                     */
/*  FILE        :Main.c or Main.cpp                                    */
/*  DATE        :Tue, Oct 31, 2006                                     */
/*  DESCRIPTION :Main Program                                          */
/*  CPU TYPE    :                                                      */
/*                                                                     */
/*  NOTE:THIS IS A TYPICAL EXAMPLE.                                    */
/*                                                                     */
/***********************************************************************/
//#include "typedefine.h"
#include <machine.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <math.h>
#include <mathf.h>
#include <complex.h>
#include "iodefine.h"
#include "ada_if.h"
#include "sci.h"
#include "board.h"
#include "sound_effect.h"


#ifdef __cplusplus
//#include <ios>                        // Remove the comment when you use ios
//_SINT ios_base::Init::init_cnt;       // Remove the comment when you use ios
#endif

void main(void);
#ifdef __cplusplus
extern "C" {
void abort(void);
}
#endif

void main(void)
{
	unsigned char xc;
	short volume_up_down[3] = {0, 0, 0};
	unsigned long local_sw_state;
	
	int offset = 0;
	
	int i;
	
	int ret;
	
	const int data_handling_size = 128;	//128f[^i1/48kHz=20.83us@20.83us x 128 = 2.67msjɃf[^
	
	volatile unsigned long x;
	
	sci_init();
	
	sci_write_str("\n");
	sci_write_str("Copyright (C) 2021 HokutoDenshi. All Rights Reserved.\n");
	sci_write_str("ADA-IF sample program for (HSBRX72M176, HSBRX72N176, HSBRX66N176, HSBRX72N144, HSBRX66N144).\n\n");
	
	sci_write_str("COMMAND USAGE:\n");
	sci_write_str("  SW2: Operation mode change\n");
	sci_write_str("  0-9: Operation mode change\n");
#if (USE_ADC == 0)	//ADCgpȂꍇ́AL[{[hŃ{[𒲐
	sci_write_str("  q,a,z: Volume1 down (q:100, a:10, z:1)\n");
	sci_write_str("  w,s,x: Volume1 up   (w:100, s:10, x:1)\n");
	sci_write_str("  e,d,c: Volume2 down (e:100, d:10, c:1)\n");
	sci_write_str("  r,f,v: Volume2 up   (r:100, f:10, v:1)\n");
	sci_write_str("  t,g,b: Volume3 down (t:100, g:10, b:1)\n");
	sci_write_str("  y,h,n: Volume3 up   (y:100, h:10, n:1)\n");
#endif
	sci_write_str("  p: print current status\n");
	
	sci_write_str("\n");
	sci_write_str("\nOperation mode -> Thru\n");
	
	sci_write_str("\n>");

	sci_write_flush();

	g_input_index = 0;								//̓obt@0珈Jn
	g_output_index = 0 - 256 + DATA_BUFFER_SIZE;	//o̓obt@256|CgOi1/48kHz=20.83us 20.83us x 256 = 5.3msjf[^i[n߂

	ada_if_init( );
	ret = ada_if_start( );
	
	if(ret != 0)
	{
		//{[hڑG[
		sci_write_str("\n\n");
		sci_write_str("ADA-IF board cannot initialize.\n\n");
		sci_write_str("Please check board connection.\n\n");
		sci_write_str("Program opeation stopped.\n");
		
		while(1)
		{
			__nop();
		}
	}
	
	local_sw_state = g_sw_state;
	
	while(1)
	{
		//f[^
		if(ada_if_input_index_diff(offset, g_input_index) > data_handling_size)	//̃f[^ data_handling_size ȏł΃f[^iDATA_BUFFER_SIZEdata_handling_size̐{Ƃj
		{
			switch(local_sw_state)
			{
				case 0:
					//X[
					for(i=0; i<data_handling_size; i++)
					{
						g_pcm1[offset + i] = g_pcm0[offset + i];		//̓f[^̂܂܏o͂ɃRs[
					}
					break;
					
				case 1:
					//fBC
					delay(offset, data_handling_size);
					break;
					
				case 2:
					//o[u
					reverb(offset, data_handling_size);
					break;
					
				case 3:
					//fBXg[V
					distortion(offset, data_handling_size);
					break;
					
				case 4:
					//E
					wah(offset, data_handling_size);
					break;
				
				case 5:
					//g
					tremolo(offset, data_handling_size);
					break;
					
				case 6:
					//ru[g
					vibrart(offset, data_handling_size);
					break;
					
				case 7:
					//R[X
					chorus(offset, data_handling_size);
					break;
					
				case 8:
					//tW
					flanger(offset, data_handling_size);
					break;
					
				case 9:
					//WI{CX
					radio_voice(offset, data_handling_size);
					break;
				
				default:
					break;
			}
			
			offset += data_handling_size;
			if(offset >= DATA_BUFFER_SIZE) offset -= DATA_BUFFER_SIZE;
		}
		
		if(local_sw_state != g_sw_state)
		{
			local_sw_state = g_sw_state;
			
			//XCb`ꂽ[烂[hύX
			switch(local_sw_state)
			{
				case 0:
					//X[
					sci_write_str("\nOperation mode(0) -> Thru\n");
					g_led_pattern = 0;		//LED
					break;
					
				case 1:
					//fBC
					sci_write_str("\nOperation mode(1) -> Delay\n");
					g_led_pattern = 0x1;	//LED1_
					break;
					
				case 2:
					//o[u
					sci_write_str("\nOperation mode(2) -> Reverb\n");
					g_led_pattern = 0x5;	//LED2_
					break;
					
				case 3:
					//fBXg[V
					sci_write_str("\nOperation mode(3) -> Distortion\n");
					g_led_pattern = 0x15;	//LED3_
					break;
					
				case 4:
					//E
					sci_write_str("\nOperation mode(4) -> Wah\n");
					g_led_pattern = 0x55;	//LED4_
					break;
				
				case 5:
					//g
					sci_write_str("\nOperation mode(5) -> Tremolo\n");
					g_led_pattern = 0x155;	//LED5_
					break;
					
				case 6:
					//ru[g
					sci_write_str("\nOperation mode(6) -> Vibrart\n");
					g_led_pattern = 0x555;	//LED6_
					break;
					
				case 7:
					//R[X
					sci_write_str("\nOperation mode(7) -> Chorus\n");
					g_led_pattern = 0x1555;	//LED7_
					break;
					
				case 8:
					//tW
					sci_write_str("\nOperation mode(8) -> Flanger\n");
					g_led_pattern = 0x5555;	//LED8_
					break;
					
				case 9:
					//WI{CX
					sci_write_str("\nOperation mode(9) -> Radio_voice\n");
					g_led_pattern = 0x15555;	//LED9_
					break;
			}
			sci_write_str("\n>");
		}
		
#if (USE_SCI == 1)
		xc = sci_read_char();
	
		if(xc != 0xff)
		{
			switch(xc)
			{
				case '0':
					sci_write_char(xc);
					g_sw_state = 0;
					break;
				
				case '1':
					sci_write_char(xc);
					g_sw_state = 1;
					break;
				
				case '2':
					sci_write_char(xc);
					g_sw_state = 2;
					break;
				
				case '3':
					sci_write_char(xc);
					g_sw_state = 3;
					break;
				
				case '4':
					sci_write_char(xc);
					g_sw_state = 4;
					break;
				
				case '5':
					sci_write_char(xc);
					g_sw_state = 5;
					break;
				
				case '6':
					sci_write_char(xc);
					g_sw_state = 6;
					break;
					
				case '7':
					sci_write_char(xc);
					g_sw_state = 7;
					break;
					
				case '8':
					sci_write_char(xc);
					g_sw_state = 8;
					break;
					
				case '9':
					sci_write_char(xc);
					g_sw_state = 9;
					break;
					
#if (USE_ADC == 0)
				case 'q':
					sci_write_char(xc);
					volume_up_down[0] = -100;
					break;
				
				case 'w':
					sci_write_char(xc);
					volume_up_down[0] = 100;
					break;
				
				case 'e':
					sci_write_char(xc);
					volume_up_down[1] = -100;
					break;
				
				case 'r':
					sci_write_char(xc);
					volume_up_down[1] = 100;
					break;
				
				case 't':
					sci_write_char(xc);
					volume_up_down[2] = -100;
					break;
				
				case 'y':
					sci_write_char(xc);
					volume_up_down[2] = 100;
					break;
		
				case 'a':
					sci_write_char(xc);
					volume_up_down[0] = -10;
					break;
				
				case 's':
					sci_write_char(xc);
					volume_up_down[0] = 10;
					break;
				
				case 'd':
					sci_write_char(xc);
					volume_up_down[1] = -10;
					break;
				
				case 'f':
					sci_write_char(xc);
					volume_up_down[1] = 10;
					break;
				
				case 'g':
					sci_write_char(xc);
					volume_up_down[2] = -10;
					break;
				
				case 'h':
					sci_write_char(xc);
					volume_up_down[2] = 10;
					break;
				
				case 'z':
					sci_write_char(xc);
					volume_up_down[0] = -1;
					break;
				
				case 'x':
					sci_write_char(xc);
					volume_up_down[0] = 1;
					break;
				
				case 'c':
					sci_write_char(xc);
					volume_up_down[1] = -1;
					break;
				
				case 'v':
					sci_write_char(xc);
					volume_up_down[1] = 1;
					break;
				
				case 'b':
					sci_write_char(xc);
					volume_up_down[2] = -1;
					break;
				
				case 'n':
					sci_write_char(xc);
					volume_up_down[2] = 1;
					break;
#endif
				case 'p':
					sci_write_char(xc);
					sci_write_str("\nvolume(0, 1, 2) = (");
					sci_write_uint16(g_ad_val[0]);
					sci_write_str(", ");
					sci_write_uint16(g_ad_val[1]);
					sci_write_str(", ");
					sci_write_uint16(g_ad_val[2]);
					sci_write_str(") sw = ");
					sci_write_uint32(g_sw_state);
					sci_write_str("\n\n>");
					break;
			}
		}
	
#if (USE_ADC == 0)	
		for(i=0; i<3; i++)
		{
			if(volume_up_down[i] != 0)
			{
				sci_write_str("\nvolume(");
				sci_write_uint8((unsigned char)i);
				sci_write_str(") ");
				if(volume_up_down[i] > 0) sci_write_str("+");
				sci_write_int16(volume_up_down[i]);
				
				volume_up_down[i] += g_ad_val[i];
				if(volume_up_down[i] < 0) g_ad_val[i] = 0;
				else if(volume_up_down[i] > 4095) g_ad_val[i] = 4095;
				else g_ad_val[i] = volume_up_down[i];
				volume_up_down[i] = 0;
				
				sci_write_str(" -> ");
				sci_write_uint16(g_ad_val[i]);
				sci_write_str("\n");
				sci_write_str("\n\n>");
			}
		}
#endif
	
#endif

	}

}

#ifdef __cplusplus
void abort(void)
{

}
#endif
